#!/bin/ksh
#\
exec wish "$0" "$@"

proc _prefs {w} {
global labelbgcolor labelfgcolor labelfont 
global buttonbgcolor buttonfgcolor buttonfont
global entrybgcolor entryfgcolor entryfont
global prefslist rexdir
global et td dd as kc aso

if [winfo exists $w] return
toplevel $w
wm title $w "Prefs Editor"
wm iconname $w "Prefs Editor"
grab $w

_iframe $w.f1 "Name" -wid 320 -he 20 -bg $labelbgcolor
entry $w.f1.f.e \
	-fg $entryfgcolor -bg $entrybgcolor -font $entryfont -width 35
pack $w.f1.f.e
pack $w.f1 -fill x

_iframe $w.f2 "Earth Time" -he 30 -bg $labelbgcolor
radiobutton $w.f2.f.r1 -variable et -text "Home" -value 0 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f2.f.r2 -variable et -text "World" -value 1 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
pack $w.f2.f.r1 -expand yes -fill both -side left
pack $w.f2.f.r2 -expand yes -fill both -side right
pack $w.f2 -fill x

_iframe $w.f3 "Time Display" -he 30 -bg $labelbgcolor
radiobutton $w.f3.f.r1 -variable td -text "12 hr" -value 0 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f3.f.r2 -variable td -text "24 hr" -value 1 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
pack $w.f3.f.r1 -side left -expand yes -fill both 
pack $w.f3.f.r2 -side right -expand yes -fill both 
pack $w.f3 -fill x

_iframe $w.f4 "Date Display" -bg $labelbgcolor
set m [tk_optionMenu $w.f4.f.m ddvar \
	"Mon DD, YYYY" \
	"DD Mon, YYYY" \
	"Weekday MM/DD/YY" \
	"YYYY Mon DD" \
	"YYYY/MM/DD"]
$m configure -fg $labelfgcolor -bg $labelbgcolor -font $labelfont
$w.f4.f.m configure  -bg $labelbgcolor -font $labelfont \
	-relief flat -bd 0 -activeback $labelbgcolor \
	-highlightthickness 0
for {set i 0} {$i < [$m index last]} {incr i} {
	$m entryconfigure $i -command "set dd $i"
}
pack $w.f4.f.m -expand yes -fill both -side right
pack $w.f4 -fill x

_iframe $w.f5 "Alarm Sound" -he 30 -bg $labelbgcolor
radiobutton $w.f5.f.r1 -variable as -text "Off   " -value 0 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f5.f.r2 -variable as -text "Short " -value 1 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f5.f.r3 -variable as -text "Long  " -value 2 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
pack $w.f5.f.r3 -expand yes -fill both -side right
pack $w.f5.f.r2 -expand yes -fill both -side right
pack $w.f5.f.r1 -expand yes -fill both -side right
pack $w.f5 -fill x

_iframe $w.f6 "Key Clicks" -he 30 -bg $labelbgcolor
radiobutton $w.f6.f.r1 -variable kc -text "Off  " -value 0 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f6.f.r2 -variable kc -text "Soft   " -value 1 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f6.f.r3 -variable kc -text "Loud  " -value 2 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
pack $w.f6.f.r3 -expand yes -fill both -side right
pack $w.f6.f.r2 -expand yes -fill both -side right
pack $w.f6.f.r1 -expand yes -fill both -side right
pack $w.f6 -fill x

_iframe $w.f7 "Auto Shut Off" -he 30 -bg $labelbgcolor
radiobutton $w.f7.f.r1 -variable aso -text "1 min" -value 0 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f7.f.r2 -variable aso -text "3 mins" -value 1 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
radiobutton $w.f7.f.r3 -variable aso -text "5 mins" -value 2 \
	-font $labelfont -bg $labelbgcolor \
	-highlightthickness 0 -activebackground $labelbgcolor
pack $w.f7.f.r3 -expand yes -fill both -side right
pack $w.f7.f.r2 -expand yes -fill both -side right
pack $w.f7.f.r1 -expand yes -fill both -side right
pack $w.f7 -fill x

frame $w.b -bg $labelbgcolor -bd 2 -re ridge
button $w.b.s -text Save -command "save_prefs {$w}" \
	-bg $buttonbgcolor -font $buttonfont -fg $buttonfgcolor -bd 1
button $w.b.d  -text Dismiss -command "destroy {$w}" \
	-bg $buttonbgcolor -font $buttonfont -fg $buttonfgcolor -bd 1
pack $w.b.s -expand yes -fill x -side left 
pack $w.b.d -expand yes -fill x -side right
pack $w.b -fill x

set prefs [lindex $prefslist 0]
set et [lindex $prefs 1]
set td [lindex $prefs 2]
set dd [lindex $prefs 3]
set as [lindex $prefs 4]
set kc [lindex $prefs 5]
set aso [lindex $prefs 6]
$w.f4.f.m.menu invoke $dd
instext $w.f1.f.e [lindex $prefs 7]
$w.f1.f.e config -state normal
}

proc save_prefs {w} {
global prefslist
global et td dd as kc aso
set name [$w.f1.f.e get]
set prefslist [list "prefs $et $td $dd $as $kc $aso \"$name\""]
}
